
#include <Servo.h>



int photoPin = 0;
int thermPin = 1;
int SERVO_PIN = 12;

unsigned long lastSampleTime = 0;
int sampleInterval = 100;
const int sampleSize = 16;
//int sample1 = 0;
//int sample2 = 0;
int readings1[sampleSize];
int readings2[sampleSize];
int sampleNumber = 0;

unsigned int median1 = 0;
unsigned int low1 = 1024;
unsigned int high1 = 0;
unsigned int mean1 = 0;

unsigned int median2 = 0;
unsigned int low2 = 1024;
unsigned int high2 = 0;
unsigned int mean2 = 0;

Servo wiggling_servo;


void setup() {
  Serial.begin(115200);
  pinMode(photoPin, INPUT);
  pinMode(thermPin, INPUT);

}

void loop() {

 unsigned long now = millis();

 if (lastSampleTime + sampleInterval < now) {
  lastSampleTime = now;
  unsigned int photo = analogRead(photoPin);
  unsigned int therm = analogRead(thermPin);

  readings1[sampleNumber] = photo;
  readings2[sampleNumber] = therm;

  if (sampleNumber < (sampleSize - 1)){
    sampleNumber++;
  }
  if (sampleNumber = (sampleSize-1)){
    sampleNumber = 0;
  }

  digitalWrite (photoPin, HIGH);
  digitalWrite (thermPin, HIGH);

  for (int i = 0; i < sampleSize; i++) {
    mean1 += readings1[i];
    mean2 += readings2[i];
    if (readings1[i] < low1) {
      low1 = readings1[i];
    }
    if (readings2[i] < low2) {
      low2 = readings2[i];
    }
    if (readings1[i] > high1) {
      high1 = readings1[i];
    }
    if (readings2[i] > high2) {
      high2 = readings2[i];
    }
  }

  mean1 = mean1/sampleSize;
  mean2 = mean2/sampleSize;

  Serial.println(mean1);
  Serial.println(mean2);
  
  bubbleSort1();
  bubbleSort2();
  median1 = readings1[sampleSize/2];
  median2 = readings2[sampleSize/2];
 }

 linear_move(0,360,(median1/median2)*10);

}

//linear_move code from Garth's website
void linear_move(int start, int end, float speed)
{
  const int interval = 20;
  float step = speed * 0.001 * interval;
  float angle = start;
  do {
    wiggling_servo.write(angle);  // update the servo output
    delay(interval);     // pause for the sampling interval

    if (end >= start) {
      angle += step;       // movement in the positive direction
      if (angle > end) angle = end;
    } else {
      angle -= step;      // movement in the negative direction
      if (angle < end) angle = end;
    }
  } while (angle != end);

  // Update the servo with the exact endpoint before returning.
  wiggling_servo.write(end);
}


//tigoe's sort --- puts array numbers in order
void bubbleSort1() {
  int out, in, swapper;
  for(out=0 ; out < sampleSize; out++) {  // outer loop
    for(in=out; in<(sampleSize-1); in++)  {  // inner loop
      if( readings1[in] > readings1[in+1] ) {   // out of order?
        // swap them:
        swapper = readings1[in];
        readings1[in] = readings1[in+1];
        readings1[in+1] = swapper;
      }
    }
  }
}

void bubbleSort2() {
  int out, in, swapper;
  for(out=0 ; out < sampleSize; out++) {  // outer loop
    for(in=out; in<(sampleSize-1); in++)  {  // inner loop
      if( readings2[in] > readings2[in+1] ) {   // out of order?
        // swap them:
        swapper = readings2[in];
        readings2[in] = readings2[in+1];
        readings2[in+1] = swapper;
      }
    }
  }
}
